'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _util = require('./util');

var _router = require('./router');

var _router2 = _interopRequireDefault(_router);

/**
 * Installation interface.
 * Install the necessary directives.
 */

_router2['default'].install = function (Vue) {
  /* istanbul ignore if */
  if (_router2['default'].installed) {
    (0, _util.warn)('already installed.');
    return;
  }
  require('./router/api')(Vue, _router2['default']);
  require('./router/internal')(Vue, _router2['default']);
  require('./directives/view')(Vue);
  require('./directives/link')(Vue);
  require('./override')(Vue);
  _router2['default'].Vue = Vue;
  _router2['default'].installed = true;
};

// auto install
/* istanbul ignore if */
if (typeof window !== 'undefined' && window.Vue) {
  window.Vue.use(_router2['default']);
}

exports['default'] = _router2['default'];
module.exports = exports['default'];