/**
 * Route Context Object
 *
 * @param {String} path
 * @param {Router} router
 */

"use strict";

var _classCallCheck = require("babel-runtime/helpers/class-call-check")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});

var Route = function Route(path, router) {
  _classCallCheck(this, Route);

  this.path = path;
  this.router = router;

  var matched = router._recognizer.recognize(path);

  this.query = matched ? matched.queryParams : {};

  this.params = matched ? [].reduce.call(matched, function (prev, cur) {
    if (cur.params) {
      for (var key in cur.params) {
        prev[key] = cur.params[key];
      }
    }
    return prev;
  }, {}) : {};

  // private stuff
  this._matched = matched || router._notFoundHandler;
};

exports["default"] = Route;
module.exports = exports["default"];